# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'WorkloadComplianceStatusArgs',
    'WorkloadComplianceStatusArgsDict',
    'WorkloadEkmProvisioningResponseArgs',
    'WorkloadEkmProvisioningResponseArgsDict',
    'WorkloadKmsSettingsArgs',
    'WorkloadKmsSettingsArgsDict',
    'WorkloadPartnerPermissionsArgs',
    'WorkloadPartnerPermissionsArgsDict',
    'WorkloadResourceArgs',
    'WorkloadResourceArgsDict',
    'WorkloadResourceSettingArgs',
    'WorkloadResourceSettingArgsDict',
    'WorkloadSaaEnrollmentResponseArgs',
    'WorkloadSaaEnrollmentResponseArgsDict',
    'WorkloadWorkloadOptionsArgs',
    'WorkloadWorkloadOptionsArgsDict',
]

MYPY = False

if not MYPY:
    class WorkloadComplianceStatusArgsDict(TypedDict):
        acknowledged_violation_counts: NotRequired[pulumi.Input[Sequence[pulumi.Input[int]]]]
        """
        Number of current orgPolicy violations which are acknowledged.
        """
        active_violation_counts: NotRequired[pulumi.Input[Sequence[pulumi.Input[int]]]]
        """
        Number of current orgPolicy violations which are not acknowledged.
        """
elif False:
    WorkloadComplianceStatusArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class WorkloadComplianceStatusArgs:
    def __init__(__self__, *,
                 acknowledged_violation_counts: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None,
                 active_violation_counts: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]] = None):
        """
        :param pulumi.Input[Sequence[pulumi.Input[int]]] acknowledged_violation_counts: Number of current orgPolicy violations which are acknowledged.
        :param pulumi.Input[Sequence[pulumi.Input[int]]] active_violation_counts: Number of current orgPolicy violations which are not acknowledged.
        """
        if acknowledged_violation_counts is not None:
            pulumi.set(__self__, "acknowledged_violation_counts", acknowledged_violation_counts)
        if active_violation_counts is not None:
            pulumi.set(__self__, "active_violation_counts", active_violation_counts)

    @property
    @pulumi.getter(name="acknowledgedViolationCounts")
    def acknowledged_violation_counts(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        Number of current orgPolicy violations which are acknowledged.
        """
        return pulumi.get(self, "acknowledged_violation_counts")

    @acknowledged_violation_counts.setter
    def acknowledged_violation_counts(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "acknowledged_violation_counts", value)

    @property
    @pulumi.getter(name="activeViolationCounts")
    def active_violation_counts(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]:
        """
        Number of current orgPolicy violations which are not acknowledged.
        """
        return pulumi.get(self, "active_violation_counts")

    @active_violation_counts.setter
    def active_violation_counts(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[int]]]]):
        pulumi.set(self, "active_violation_counts", value)


if not MYPY:
    class WorkloadEkmProvisioningResponseArgsDict(TypedDict):
        ekm_provisioning_error_domain: NotRequired[pulumi.Input[str]]
        """
        Indicates Ekm provisioning error if any. Possible values: EKM_PROVISIONING_ERROR_DOMAIN_UNSPECIFIED, UNSPECIFIED_ERROR, GOOGLE_SERVER_ERROR, EXTERNAL_USER_ERROR, EXTERNAL_PARTNER_ERROR, TIMEOUT_ERROR
        """
        ekm_provisioning_error_mapping: NotRequired[pulumi.Input[str]]
        """
        Detailed error message if Ekm provisioning fails Possible values: EKM_PROVISIONING_ERROR_MAPPING_UNSPECIFIED, INVALID_SERVICE_ACCOUNT, MISSING_METRICS_SCOPE_ADMIN_PERMISSION, MISSING_EKM_CONNECTION_ADMIN_PERMISSION
        """
        ekm_provisioning_state: NotRequired[pulumi.Input[str]]
        """
        Indicates Ekm enrollment Provisioning of a given workload. Possible values: EKM_PROVISIONING_STATE_UNSPECIFIED, EKM_PROVISIONING_STATE_PENDING, EKM_PROVISIONING_STATE_FAILED, EKM_PROVISIONING_STATE_COMPLETED
        """
elif False:
    WorkloadEkmProvisioningResponseArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class WorkloadEkmProvisioningResponseArgs:
    def __init__(__self__, *,
                 ekm_provisioning_error_domain: Optional[pulumi.Input[str]] = None,
                 ekm_provisioning_error_mapping: Optional[pulumi.Input[str]] = None,
                 ekm_provisioning_state: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] ekm_provisioning_error_domain: Indicates Ekm provisioning error if any. Possible values: EKM_PROVISIONING_ERROR_DOMAIN_UNSPECIFIED, UNSPECIFIED_ERROR, GOOGLE_SERVER_ERROR, EXTERNAL_USER_ERROR, EXTERNAL_PARTNER_ERROR, TIMEOUT_ERROR
        :param pulumi.Input[str] ekm_provisioning_error_mapping: Detailed error message if Ekm provisioning fails Possible values: EKM_PROVISIONING_ERROR_MAPPING_UNSPECIFIED, INVALID_SERVICE_ACCOUNT, MISSING_METRICS_SCOPE_ADMIN_PERMISSION, MISSING_EKM_CONNECTION_ADMIN_PERMISSION
        :param pulumi.Input[str] ekm_provisioning_state: Indicates Ekm enrollment Provisioning of a given workload. Possible values: EKM_PROVISIONING_STATE_UNSPECIFIED, EKM_PROVISIONING_STATE_PENDING, EKM_PROVISIONING_STATE_FAILED, EKM_PROVISIONING_STATE_COMPLETED
        """
        if ekm_provisioning_error_domain is not None:
            pulumi.set(__self__, "ekm_provisioning_error_domain", ekm_provisioning_error_domain)
        if ekm_provisioning_error_mapping is not None:
            pulumi.set(__self__, "ekm_provisioning_error_mapping", ekm_provisioning_error_mapping)
        if ekm_provisioning_state is not None:
            pulumi.set(__self__, "ekm_provisioning_state", ekm_provisioning_state)

    @property
    @pulumi.getter(name="ekmProvisioningErrorDomain")
    def ekm_provisioning_error_domain(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates Ekm provisioning error if any. Possible values: EKM_PROVISIONING_ERROR_DOMAIN_UNSPECIFIED, UNSPECIFIED_ERROR, GOOGLE_SERVER_ERROR, EXTERNAL_USER_ERROR, EXTERNAL_PARTNER_ERROR, TIMEOUT_ERROR
        """
        return pulumi.get(self, "ekm_provisioning_error_domain")

    @ekm_provisioning_error_domain.setter
    def ekm_provisioning_error_domain(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ekm_provisioning_error_domain", value)

    @property
    @pulumi.getter(name="ekmProvisioningErrorMapping")
    def ekm_provisioning_error_mapping(self) -> Optional[pulumi.Input[str]]:
        """
        Detailed error message if Ekm provisioning fails Possible values: EKM_PROVISIONING_ERROR_MAPPING_UNSPECIFIED, INVALID_SERVICE_ACCOUNT, MISSING_METRICS_SCOPE_ADMIN_PERMISSION, MISSING_EKM_CONNECTION_ADMIN_PERMISSION
        """
        return pulumi.get(self, "ekm_provisioning_error_mapping")

    @ekm_provisioning_error_mapping.setter
    def ekm_provisioning_error_mapping(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ekm_provisioning_error_mapping", value)

    @property
    @pulumi.getter(name="ekmProvisioningState")
    def ekm_provisioning_state(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates Ekm enrollment Provisioning of a given workload. Possible values: EKM_PROVISIONING_STATE_UNSPECIFIED, EKM_PROVISIONING_STATE_PENDING, EKM_PROVISIONING_STATE_FAILED, EKM_PROVISIONING_STATE_COMPLETED
        """
        return pulumi.get(self, "ekm_provisioning_state")

    @ekm_provisioning_state.setter
    def ekm_provisioning_state(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "ekm_provisioning_state", value)


if not MYPY:
    class WorkloadKmsSettingsArgsDict(TypedDict):
        next_rotation_time: pulumi.Input[str]
        """
        Required. Input only. Immutable. The time at which the Key Management Service will automatically create a new version of the crypto key and mark it as the primary.
        """
        rotation_period: pulumi.Input[str]
        """
        Required. Input only. Immutable. will be advanced by this period when the Key Management Service automatically rotates a key. Must be at least 24 hours and at most 876,000 hours.
        """
elif False:
    WorkloadKmsSettingsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class WorkloadKmsSettingsArgs:
    def __init__(__self__, *,
                 next_rotation_time: pulumi.Input[str],
                 rotation_period: pulumi.Input[str]):
        """
        :param pulumi.Input[str] next_rotation_time: Required. Input only. Immutable. The time at which the Key Management Service will automatically create a new version of the crypto key and mark it as the primary.
        :param pulumi.Input[str] rotation_period: Required. Input only. Immutable. will be advanced by this period when the Key Management Service automatically rotates a key. Must be at least 24 hours and at most 876,000 hours.
        """
        pulumi.set(__self__, "next_rotation_time", next_rotation_time)
        pulumi.set(__self__, "rotation_period", rotation_period)

    @property
    @pulumi.getter(name="nextRotationTime")
    def next_rotation_time(self) -> pulumi.Input[str]:
        """
        Required. Input only. Immutable. The time at which the Key Management Service will automatically create a new version of the crypto key and mark it as the primary.
        """
        return pulumi.get(self, "next_rotation_time")

    @next_rotation_time.setter
    def next_rotation_time(self, value: pulumi.Input[str]):
        pulumi.set(self, "next_rotation_time", value)

    @property
    @pulumi.getter(name="rotationPeriod")
    def rotation_period(self) -> pulumi.Input[str]:
        """
        Required. Input only. Immutable. will be advanced by this period when the Key Management Service automatically rotates a key. Must be at least 24 hours and at most 876,000 hours.
        """
        return pulumi.get(self, "rotation_period")

    @rotation_period.setter
    def rotation_period(self, value: pulumi.Input[str]):
        pulumi.set(self, "rotation_period", value)


if not MYPY:
    class WorkloadPartnerPermissionsArgsDict(TypedDict):
        assured_workloads_monitoring: NotRequired[pulumi.Input[bool]]
        """
        Optional. Allow partner to view violation alerts.
        """
        data_logs_viewer: NotRequired[pulumi.Input[bool]]
        """
        Allow the partner to view inspectability logs and monitoring violations.
        """
        service_access_approver: NotRequired[pulumi.Input[bool]]
        """
        Optional. Allow partner to view access approval logs.
        """
elif False:
    WorkloadPartnerPermissionsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class WorkloadPartnerPermissionsArgs:
    def __init__(__self__, *,
                 assured_workloads_monitoring: Optional[pulumi.Input[bool]] = None,
                 data_logs_viewer: Optional[pulumi.Input[bool]] = None,
                 service_access_approver: Optional[pulumi.Input[bool]] = None):
        """
        :param pulumi.Input[bool] assured_workloads_monitoring: Optional. Allow partner to view violation alerts.
        :param pulumi.Input[bool] data_logs_viewer: Allow the partner to view inspectability logs and monitoring violations.
        :param pulumi.Input[bool] service_access_approver: Optional. Allow partner to view access approval logs.
        """
        if assured_workloads_monitoring is not None:
            pulumi.set(__self__, "assured_workloads_monitoring", assured_workloads_monitoring)
        if data_logs_viewer is not None:
            pulumi.set(__self__, "data_logs_viewer", data_logs_viewer)
        if service_access_approver is not None:
            pulumi.set(__self__, "service_access_approver", service_access_approver)

    @property
    @pulumi.getter(name="assuredWorkloadsMonitoring")
    def assured_workloads_monitoring(self) -> Optional[pulumi.Input[bool]]:
        """
        Optional. Allow partner to view violation alerts.
        """
        return pulumi.get(self, "assured_workloads_monitoring")

    @assured_workloads_monitoring.setter
    def assured_workloads_monitoring(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "assured_workloads_monitoring", value)

    @property
    @pulumi.getter(name="dataLogsViewer")
    def data_logs_viewer(self) -> Optional[pulumi.Input[bool]]:
        """
        Allow the partner to view inspectability logs and monitoring violations.
        """
        return pulumi.get(self, "data_logs_viewer")

    @data_logs_viewer.setter
    def data_logs_viewer(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "data_logs_viewer", value)

    @property
    @pulumi.getter(name="serviceAccessApprover")
    def service_access_approver(self) -> Optional[pulumi.Input[bool]]:
        """
        Optional. Allow partner to view access approval logs.
        """
        return pulumi.get(self, "service_access_approver")

    @service_access_approver.setter
    def service_access_approver(self, value: Optional[pulumi.Input[bool]]):
        pulumi.set(self, "service_access_approver", value)


if not MYPY:
    class WorkloadResourceArgsDict(TypedDict):
        resource_id: NotRequired[pulumi.Input[int]]
        """
        Resource identifier. For a project this represents project_number.
        """
        resource_type: NotRequired[pulumi.Input[str]]
        """
        Indicates the type of resource. Possible values: RESOURCE_TYPE_UNSPECIFIED, CONSUMER_PROJECT, ENCRYPTION_KEYS_PROJECT, KEYRING, CONSUMER_FOLDER
        """
elif False:
    WorkloadResourceArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class WorkloadResourceArgs:
    def __init__(__self__, *,
                 resource_id: Optional[pulumi.Input[int]] = None,
                 resource_type: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[int] resource_id: Resource identifier. For a project this represents project_number.
        :param pulumi.Input[str] resource_type: Indicates the type of resource. Possible values: RESOURCE_TYPE_UNSPECIFIED, CONSUMER_PROJECT, ENCRYPTION_KEYS_PROJECT, KEYRING, CONSUMER_FOLDER
        """
        if resource_id is not None:
            pulumi.set(__self__, "resource_id", resource_id)
        if resource_type is not None:
            pulumi.set(__self__, "resource_type", resource_type)

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> Optional[pulumi.Input[int]]:
        """
        Resource identifier. For a project this represents project_number.
        """
        return pulumi.get(self, "resource_id")

    @resource_id.setter
    def resource_id(self, value: Optional[pulumi.Input[int]]):
        pulumi.set(self, "resource_id", value)

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the type of resource. Possible values: RESOURCE_TYPE_UNSPECIFIED, CONSUMER_PROJECT, ENCRYPTION_KEYS_PROJECT, KEYRING, CONSUMER_FOLDER
        """
        return pulumi.get(self, "resource_type")

    @resource_type.setter
    def resource_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resource_type", value)


if not MYPY:
    class WorkloadResourceSettingArgsDict(TypedDict):
        display_name: NotRequired[pulumi.Input[str]]
        """
        User-assigned resource display name. If not empty it will be used to create a resource with the specified name.
        """
        resource_id: NotRequired[pulumi.Input[str]]
        """
        Resource identifier. For a project this represents projectId. If the project is already taken, the workload creation will fail. For KeyRing, this represents the keyring_id. For a folder, don't set this value as folder_id is assigned by Google.
        """
        resource_type: NotRequired[pulumi.Input[str]]
        """
        Indicates the type of resource. This field should be specified to correspond the id to the right project type (CONSUMER_PROJECT or ENCRYPTION_KEYS_PROJECT) Possible values: RESOURCE_TYPE_UNSPECIFIED, CONSUMER_PROJECT, ENCRYPTION_KEYS_PROJECT, KEYRING, CONSUMER_FOLDER
        """
elif False:
    WorkloadResourceSettingArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class WorkloadResourceSettingArgs:
    def __init__(__self__, *,
                 display_name: Optional[pulumi.Input[str]] = None,
                 resource_id: Optional[pulumi.Input[str]] = None,
                 resource_type: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] display_name: User-assigned resource display name. If not empty it will be used to create a resource with the specified name.
        :param pulumi.Input[str] resource_id: Resource identifier. For a project this represents projectId. If the project is already taken, the workload creation will fail. For KeyRing, this represents the keyring_id. For a folder, don't set this value as folder_id is assigned by Google.
        :param pulumi.Input[str] resource_type: Indicates the type of resource. This field should be specified to correspond the id to the right project type (CONSUMER_PROJECT or ENCRYPTION_KEYS_PROJECT) Possible values: RESOURCE_TYPE_UNSPECIFIED, CONSUMER_PROJECT, ENCRYPTION_KEYS_PROJECT, KEYRING, CONSUMER_FOLDER
        """
        if display_name is not None:
            pulumi.set(__self__, "display_name", display_name)
        if resource_id is not None:
            pulumi.set(__self__, "resource_id", resource_id)
        if resource_type is not None:
            pulumi.set(__self__, "resource_type", resource_type)

    @property
    @pulumi.getter(name="displayName")
    def display_name(self) -> Optional[pulumi.Input[str]]:
        """
        User-assigned resource display name. If not empty it will be used to create a resource with the specified name.
        """
        return pulumi.get(self, "display_name")

    @display_name.setter
    def display_name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "display_name", value)

    @property
    @pulumi.getter(name="resourceId")
    def resource_id(self) -> Optional[pulumi.Input[str]]:
        """
        Resource identifier. For a project this represents projectId. If the project is already taken, the workload creation will fail. For KeyRing, this represents the keyring_id. For a folder, don't set this value as folder_id is assigned by Google.
        """
        return pulumi.get(self, "resource_id")

    @resource_id.setter
    def resource_id(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resource_id", value)

    @property
    @pulumi.getter(name="resourceType")
    def resource_type(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates the type of resource. This field should be specified to correspond the id to the right project type (CONSUMER_PROJECT or ENCRYPTION_KEYS_PROJECT) Possible values: RESOURCE_TYPE_UNSPECIFIED, CONSUMER_PROJECT, ENCRYPTION_KEYS_PROJECT, KEYRING, CONSUMER_FOLDER
        """
        return pulumi.get(self, "resource_type")

    @resource_type.setter
    def resource_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "resource_type", value)


if not MYPY:
    class WorkloadSaaEnrollmentResponseArgsDict(TypedDict):
        setup_errors: NotRequired[pulumi.Input[Sequence[pulumi.Input[str]]]]
        """
        Indicates SAA enrollment setup error if any.
        """
        setup_status: NotRequired[pulumi.Input[str]]
        """
        Indicates SAA enrollment status of a given workload. Possible values: SETUP_STATE_UNSPECIFIED, STATUS_PENDING, STATUS_COMPLETE
        """
elif False:
    WorkloadSaaEnrollmentResponseArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class WorkloadSaaEnrollmentResponseArgs:
    def __init__(__self__, *,
                 setup_errors: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]] = None,
                 setup_status: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[Sequence[pulumi.Input[str]]] setup_errors: Indicates SAA enrollment setup error if any.
        :param pulumi.Input[str] setup_status: Indicates SAA enrollment status of a given workload. Possible values: SETUP_STATE_UNSPECIFIED, STATUS_PENDING, STATUS_COMPLETE
        """
        if setup_errors is not None:
            pulumi.set(__self__, "setup_errors", setup_errors)
        if setup_status is not None:
            pulumi.set(__self__, "setup_status", setup_status)

    @property
    @pulumi.getter(name="setupErrors")
    def setup_errors(self) -> Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]:
        """
        Indicates SAA enrollment setup error if any.
        """
        return pulumi.get(self, "setup_errors")

    @setup_errors.setter
    def setup_errors(self, value: Optional[pulumi.Input[Sequence[pulumi.Input[str]]]]):
        pulumi.set(self, "setup_errors", value)

    @property
    @pulumi.getter(name="setupStatus")
    def setup_status(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates SAA enrollment status of a given workload. Possible values: SETUP_STATE_UNSPECIFIED, STATUS_PENDING, STATUS_COMPLETE
        """
        return pulumi.get(self, "setup_status")

    @setup_status.setter
    def setup_status(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "setup_status", value)


if not MYPY:
    class WorkloadWorkloadOptionsArgsDict(TypedDict):
        kaj_enrollment_type: NotRequired[pulumi.Input[str]]
        """
        Indicates type of KAJ enrollment for the workload. Currently, only specifiying KEY_ACCESS_TRANSPARENCY_OFF is implemented to not enroll in KAT-level KAJ enrollment for Regional Controls workloads. Possible values: KAJ_ENROLLMENT_TYPE_UNSPECIFIED, FULL_KAJ, EKM_ONLY, KEY_ACCESS_TRANSPARENCY_OFF
        """
elif False:
    WorkloadWorkloadOptionsArgsDict: TypeAlias = Mapping[str, Any]

@pulumi.input_type
class WorkloadWorkloadOptionsArgs:
    def __init__(__self__, *,
                 kaj_enrollment_type: Optional[pulumi.Input[str]] = None):
        """
        :param pulumi.Input[str] kaj_enrollment_type: Indicates type of KAJ enrollment for the workload. Currently, only specifiying KEY_ACCESS_TRANSPARENCY_OFF is implemented to not enroll in KAT-level KAJ enrollment for Regional Controls workloads. Possible values: KAJ_ENROLLMENT_TYPE_UNSPECIFIED, FULL_KAJ, EKM_ONLY, KEY_ACCESS_TRANSPARENCY_OFF
        """
        if kaj_enrollment_type is not None:
            pulumi.set(__self__, "kaj_enrollment_type", kaj_enrollment_type)

    @property
    @pulumi.getter(name="kajEnrollmentType")
    def kaj_enrollment_type(self) -> Optional[pulumi.Input[str]]:
        """
        Indicates type of KAJ enrollment for the workload. Currently, only specifiying KEY_ACCESS_TRANSPARENCY_OFF is implemented to not enroll in KAT-level KAJ enrollment for Regional Controls workloads. Possible values: KAJ_ENROLLMENT_TYPE_UNSPECIFIED, FULL_KAJ, EKM_ONLY, KEY_ACCESS_TRANSPARENCY_OFF
        """
        return pulumi.get(self, "kaj_enrollment_type")

    @kaj_enrollment_type.setter
    def kaj_enrollment_type(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "kaj_enrollment_type", value)


