# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities
from . import outputs
from ._inputs import *

__all__ = ['FeatureArgs', 'Feature']

@pulumi.input_type
class FeatureArgs:
    def __init__(__self__, *,
                 location: pulumi.Input[str],
                 fleet_default_member_config: Optional[pulumi.Input['FeatureFleetDefaultMemberConfigArgs']] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 spec: Optional[pulumi.Input['FeatureSpecArgs']] = None):
        """
        The set of arguments for constructing a Feature resource.
        :param pulumi.Input[str] location: The location for the resource
               
               
               - - -
        :param pulumi.Input['FeatureFleetDefaultMemberConfigArgs'] fleet_default_member_config: Optional. Fleet Default Membership Configuration.
               Structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: GCP labels for this Feature.
               **Note**: This field is non-authoritative, and will only manage the labels present in your configuration.
               Please refer to the field `effective_labels` for all of the labels present on the resource.
        :param pulumi.Input[str] name: The full, unique name of this Feature resource
        :param pulumi.Input[str] project: The ID of the project in which the resource belongs.
               If it is not provided, the provider project is used.
        :param pulumi.Input['FeatureSpecArgs'] spec: Optional. Hub-wide Feature configuration. If this Feature does not support any Hub-wide configuration, this field may be unused.
               Structure is documented below.
        """
        pulumi.set(__self__, "location", location)
        if fleet_default_member_config is not None:
            pulumi.set(__self__, "fleet_default_member_config", fleet_default_member_config)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if spec is not None:
            pulumi.set(__self__, "spec", spec)

    @property
    @pulumi.getter
    def location(self) -> pulumi.Input[str]:
        """
        The location for the resource


        - - -
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: pulumi.Input[str]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter(name="fleetDefaultMemberConfig")
    def fleet_default_member_config(self) -> Optional[pulumi.Input['FeatureFleetDefaultMemberConfigArgs']]:
        """
        Optional. Fleet Default Membership Configuration.
        Structure is documented below.
        """
        return pulumi.get(self, "fleet_default_member_config")

    @fleet_default_member_config.setter
    def fleet_default_member_config(self, value: Optional[pulumi.Input['FeatureFleetDefaultMemberConfigArgs']]):
        pulumi.set(self, "fleet_default_member_config", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        GCP labels for this Feature.
        **Note**: This field is non-authoritative, and will only manage the labels present in your configuration.
        Please refer to the field `effective_labels` for all of the labels present on the resource.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The full, unique name of this Feature resource
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the project in which the resource belongs.
        If it is not provided, the provider project is used.
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter
    def spec(self) -> Optional[pulumi.Input['FeatureSpecArgs']]:
        """
        Optional. Hub-wide Feature configuration. If this Feature does not support any Hub-wide configuration, this field may be unused.
        Structure is documented below.
        """
        return pulumi.get(self, "spec")

    @spec.setter
    def spec(self, value: Optional[pulumi.Input['FeatureSpecArgs']]):
        pulumi.set(self, "spec", value)


@pulumi.input_type
class _FeatureState:
    def __init__(__self__, *,
                 create_time: Optional[pulumi.Input[str]] = None,
                 delete_time: Optional[pulumi.Input[str]] = None,
                 effective_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 fleet_default_member_config: Optional[pulumi.Input['FeatureFleetDefaultMemberConfigArgs']] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 pulumi_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 resource_states: Optional[pulumi.Input[Sequence[pulumi.Input['FeatureResourceStateArgs']]]] = None,
                 spec: Optional[pulumi.Input['FeatureSpecArgs']] = None,
                 states: Optional[pulumi.Input[Sequence[pulumi.Input['FeatureStateArgs']]]] = None,
                 update_time: Optional[pulumi.Input[str]] = None):
        """
        Input properties used for looking up and filtering Feature resources.
        :param pulumi.Input[str] create_time: Output only. When the Feature resource was created.
        :param pulumi.Input[str] delete_time: Output only. When the Feature resource was deleted.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] effective_labels: All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        :param pulumi.Input['FeatureFleetDefaultMemberConfigArgs'] fleet_default_member_config: Optional. Fleet Default Membership Configuration.
               Structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: GCP labels for this Feature.
               **Note**: This field is non-authoritative, and will only manage the labels present in your configuration.
               Please refer to the field `effective_labels` for all of the labels present on the resource.
        :param pulumi.Input[str] location: The location for the resource
               
               
               - - -
        :param pulumi.Input[str] name: The full, unique name of this Feature resource
        :param pulumi.Input[str] project: The ID of the project in which the resource belongs.
               If it is not provided, the provider project is used.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] pulumi_labels: The combination of labels configured directly on the resource
               and default labels configured on the provider.
        :param pulumi.Input[Sequence[pulumi.Input['FeatureResourceStateArgs']]] resource_states: State of the Feature resource itself.
               Structure is documented below.
        :param pulumi.Input['FeatureSpecArgs'] spec: Optional. Hub-wide Feature configuration. If this Feature does not support any Hub-wide configuration, this field may be unused.
               Structure is documented below.
        :param pulumi.Input[Sequence[pulumi.Input['FeatureStateArgs']]] states: (Output)
               Output only. The "running state" of the Feature in this Hub.
               Structure is documented below.
        :param pulumi.Input[str] update_time: (Output)
               The time this status and any related Feature-specific details were updated. A timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to nine fractional digits. Examples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z"
        """
        if create_time is not None:
            pulumi.set(__self__, "create_time", create_time)
        if delete_time is not None:
            pulumi.set(__self__, "delete_time", delete_time)
        if effective_labels is not None:
            pulumi.set(__self__, "effective_labels", effective_labels)
        if fleet_default_member_config is not None:
            pulumi.set(__self__, "fleet_default_member_config", fleet_default_member_config)
        if labels is not None:
            pulumi.set(__self__, "labels", labels)
        if location is not None:
            pulumi.set(__self__, "location", location)
        if name is not None:
            pulumi.set(__self__, "name", name)
        if project is not None:
            pulumi.set(__self__, "project", project)
        if pulumi_labels is not None:
            pulumi.set(__self__, "pulumi_labels", pulumi_labels)
        if resource_states is not None:
            pulumi.set(__self__, "resource_states", resource_states)
        if spec is not None:
            pulumi.set(__self__, "spec", spec)
        if states is not None:
            pulumi.set(__self__, "states", states)
        if update_time is not None:
            pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> Optional[pulumi.Input[str]]:
        """
        Output only. When the Feature resource was created.
        """
        return pulumi.get(self, "create_time")

    @create_time.setter
    def create_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "create_time", value)

    @property
    @pulumi.getter(name="deleteTime")
    def delete_time(self) -> Optional[pulumi.Input[str]]:
        """
        Output only. When the Feature resource was deleted.
        """
        return pulumi.get(self, "delete_time")

    @delete_time.setter
    def delete_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "delete_time", value)

    @property
    @pulumi.getter(name="effectiveLabels")
    def effective_labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        """
        return pulumi.get(self, "effective_labels")

    @effective_labels.setter
    def effective_labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "effective_labels", value)

    @property
    @pulumi.getter(name="fleetDefaultMemberConfig")
    def fleet_default_member_config(self) -> Optional[pulumi.Input['FeatureFleetDefaultMemberConfigArgs']]:
        """
        Optional. Fleet Default Membership Configuration.
        Structure is documented below.
        """
        return pulumi.get(self, "fleet_default_member_config")

    @fleet_default_member_config.setter
    def fleet_default_member_config(self, value: Optional[pulumi.Input['FeatureFleetDefaultMemberConfigArgs']]):
        pulumi.set(self, "fleet_default_member_config", value)

    @property
    @pulumi.getter
    def labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        GCP labels for this Feature.
        **Note**: This field is non-authoritative, and will only manage the labels present in your configuration.
        Please refer to the field `effective_labels` for all of the labels present on the resource.
        """
        return pulumi.get(self, "labels")

    @labels.setter
    def labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "labels", value)

    @property
    @pulumi.getter
    def location(self) -> Optional[pulumi.Input[str]]:
        """
        The location for the resource


        - - -
        """
        return pulumi.get(self, "location")

    @location.setter
    def location(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "location", value)

    @property
    @pulumi.getter
    def name(self) -> Optional[pulumi.Input[str]]:
        """
        The full, unique name of this Feature resource
        """
        return pulumi.get(self, "name")

    @name.setter
    def name(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "name", value)

    @property
    @pulumi.getter
    def project(self) -> Optional[pulumi.Input[str]]:
        """
        The ID of the project in which the resource belongs.
        If it is not provided, the provider project is used.
        """
        return pulumi.get(self, "project")

    @project.setter
    def project(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "project", value)

    @property
    @pulumi.getter(name="pulumiLabels")
    def pulumi_labels(self) -> Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]:
        """
        The combination of labels configured directly on the resource
        and default labels configured on the provider.
        """
        return pulumi.get(self, "pulumi_labels")

    @pulumi_labels.setter
    def pulumi_labels(self, value: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]]):
        pulumi.set(self, "pulumi_labels", value)

    @property
    @pulumi.getter(name="resourceStates")
    def resource_states(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['FeatureResourceStateArgs']]]]:
        """
        State of the Feature resource itself.
        Structure is documented below.
        """
        return pulumi.get(self, "resource_states")

    @resource_states.setter
    def resource_states(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['FeatureResourceStateArgs']]]]):
        pulumi.set(self, "resource_states", value)

    @property
    @pulumi.getter
    def spec(self) -> Optional[pulumi.Input['FeatureSpecArgs']]:
        """
        Optional. Hub-wide Feature configuration. If this Feature does not support any Hub-wide configuration, this field may be unused.
        Structure is documented below.
        """
        return pulumi.get(self, "spec")

    @spec.setter
    def spec(self, value: Optional[pulumi.Input['FeatureSpecArgs']]):
        pulumi.set(self, "spec", value)

    @property
    @pulumi.getter
    def states(self) -> Optional[pulumi.Input[Sequence[pulumi.Input['FeatureStateArgs']]]]:
        """
        (Output)
        Output only. The "running state" of the Feature in this Hub.
        Structure is documented below.
        """
        return pulumi.get(self, "states")

    @states.setter
    def states(self, value: Optional[pulumi.Input[Sequence[pulumi.Input['FeatureStateArgs']]]]):
        pulumi.set(self, "states", value)

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> Optional[pulumi.Input[str]]:
        """
        (Output)
        The time this status and any related Feature-specific details were updated. A timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to nine fractional digits. Examples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z"
        """
        return pulumi.get(self, "update_time")

    @update_time.setter
    def update_time(self, value: Optional[pulumi.Input[str]]):
        pulumi.set(self, "update_time", value)


class Feature(pulumi.CustomResource):
    @overload
    def __init__(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 fleet_default_member_config: Optional[pulumi.Input[Union['FeatureFleetDefaultMemberConfigArgs', 'FeatureFleetDefaultMemberConfigArgsDict']]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 spec: Optional[pulumi.Input[Union['FeatureSpecArgs', 'FeatureSpecArgsDict']]] = None,
                 __props__=None):
        """
        Feature represents the settings and status of any Hub Feature.

        To get more information about Feature, see:

        * [API documentation](https://cloud.google.com/anthos/fleet-management/docs/reference/rest/v1/projects.locations.features)
        * How-to Guides
            * [Registering a Cluster](https://cloud.google.com/anthos/multicluster-management/connect/registering-a-cluster#register_cluster)

        ## Example Usage

        ### Gkehub Feature Multi Cluster Ingress

        ```python
        import pulumi
        import pulumi_gcp as gcp

        cluster = gcp.container.Cluster("cluster",
            name="my-cluster",
            location="us-central1-a",
            initial_node_count=1)
        membership = gcp.gkehub.Membership("membership",
            membership_id="my-membership",
            endpoint={
                "gke_cluster": {
                    "resource_link": cluster.id.apply(lambda id: f"//container.googleapis.com/{id}"),
                },
            })
        feature = gcp.gkehub.Feature("feature",
            name="multiclusteringress",
            location="global",
            spec={
                "multiclusteringress": {
                    "config_membership": membership.id,
                },
            })
        ```
        ### Gkehub Feature Multi Cluster Service Discovery

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="multiclusterservicediscovery",
            location="global",
            labels={
                "foo": "bar",
            })
        ```
        ### Gkehub Feature Anthos Service Mesh

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="servicemesh",
            location="global")
        ```
        ### Enable Fleet Observability For Default Logs With Copy

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="fleetobservability",
            location="global",
            spec={
                "fleetobservability": {
                    "logging_config": {
                        "default_config": {
                            "mode": "COPY",
                        },
                    },
                },
            })
        ```
        ### Enable Fleet Observability For Scope Logs With Move

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="fleetobservability",
            location="global",
            spec={
                "fleetobservability": {
                    "logging_config": {
                        "fleet_scope_logs_config": {
                            "mode": "MOVE",
                        },
                    },
                },
            })
        ```
        ### Enable Fleet Observability For Both Default And Scope Logs

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="fleetobservability",
            location="global",
            spec={
                "fleetobservability": {
                    "logging_config": {
                        "default_config": {
                            "mode": "COPY",
                        },
                        "fleet_scope_logs_config": {
                            "mode": "MOVE",
                        },
                    },
                },
            })
        ```
        ### Enable Fleet Default Member Config Service Mesh

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="servicemesh",
            location="global",
            fleet_default_member_config={
                "mesh": {
                    "management": "MANAGEMENT_AUTOMATIC",
                },
            })
        ```
        ### Enable Fleet Default Member Config Configmanagement

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="configmanagement",
            location="global",
            fleet_default_member_config={
                "configmanagement": {
                    "config_sync": {
                        "git": {
                            "sync_repo": "https://github.com/hashicorp/terraform",
                        },
                    },
                },
            })
        ```
        ### Enable Fleet Default Member Config Policycontroller

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="policycontroller",
            location="global",
            fleet_default_member_config={
                "policycontroller": {
                    "policy_controller_hub_config": {
                        "install_spec": "INSTALL_SPEC_ENABLED",
                        "exemptable_namespaces": ["foo"],
                        "policy_content": {
                            "bundles": [{
                                "bundle": "policy-essentials-v2022",
                                "exempted_namespaces": [
                                    "foo",
                                    "bar",
                                ],
                            }],
                            "template_library": {
                                "installation": "ALL",
                            },
                        },
                        "audit_interval_seconds": 30,
                        "referential_rules_enabled": True,
                    },
                },
            })
        ```
        ### Enable Fleet Default Member Config Policycontroller Full

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="policycontroller",
            location="global",
            fleet_default_member_config={
                "policycontroller": {
                    "policy_controller_hub_config": {
                        "install_spec": "INSTALL_SPEC_SUSPENDED",
                        "policy_content": {
                            "bundles": [
                                {
                                    "bundle": "pci-dss-v3.2.1",
                                    "exempted_namespaces": [
                                        "baz",
                                        "bar",
                                    ],
                                },
                                {
                                    "bundle": "nist-sp-800-190",
                                    "exempted_namespaces": [],
                                },
                            ],
                            "template_library": {
                                "installation": "ALL",
                            },
                        },
                        "constraint_violation_limit": 50,
                        "referential_rules_enabled": True,
                        "log_denies_enabled": True,
                        "mutation_enabled": True,
                        "deployment_configs": [
                            {
                                "component": "admission",
                                "replica_count": 2,
                                "pod_affinity": "ANTI_AFFINITY",
                            },
                            {
                                "component": "audit",
                                "container_resources": {
                                    "limits": {
                                        "memory": "1Gi",
                                        "cpu": "1.5",
                                    },
                                    "requests": {
                                        "memory": "500Mi",
                                        "cpu": "150m",
                                    },
                                },
                                "pod_tolerations": [{
                                    "key": "key1",
                                    "operator": "Equal",
                                    "value": "value1",
                                    "effect": "NoSchedule",
                                }],
                            },
                        ],
                        "monitoring": {
                            "backends": ["PROMETHEUS"],
                        },
                    },
                },
            })
        ```
        ### Enable Fleet Default Member Config Policycontroller Minimal

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="policycontroller",
            location="global",
            fleet_default_member_config={
                "policycontroller": {
                    "policy_controller_hub_config": {
                        "install_spec": "INSTALL_SPEC_ENABLED",
                        "policy_content": {},
                        "constraint_violation_limit": 50,
                        "referential_rules_enabled": True,
                        "log_denies_enabled": True,
                        "mutation_enabled": True,
                        "deployment_configs": [{
                            "component": "admission",
                        }],
                        "monitoring": {},
                    },
                },
            })
        ```
        ### Gkehub Feature Clusterupgrade

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="clusterupgrade",
            location="global",
            spec={
                "clusterupgrade": {
                    "upstream_fleets": [],
                    "post_conditions": {
                        "soaking": "60s",
                    },
                },
            })
        ```

        ## Import

        Feature can be imported using any of these accepted formats:

        * `projects/{{project}}/locations/{{location}}/features/{{name}}`

        * `{{project}}/{{location}}/{{name}}`

        * `{{location}}/{{name}}`

        When using the `pulumi import` command, Feature can be imported using one of the formats above. For example:

        ```sh
        $ pulumi import gcp:gkehub/feature:Feature default projects/{{project}}/locations/{{location}}/features/{{name}}
        ```

        ```sh
        $ pulumi import gcp:gkehub/feature:Feature default {{project}}/{{location}}/{{name}}
        ```

        ```sh
        $ pulumi import gcp:gkehub/feature:Feature default {{location}}/{{name}}
        ```

        :param str resource_name: The name of the resource.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[Union['FeatureFleetDefaultMemberConfigArgs', 'FeatureFleetDefaultMemberConfigArgsDict']] fleet_default_member_config: Optional. Fleet Default Membership Configuration.
               Structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: GCP labels for this Feature.
               **Note**: This field is non-authoritative, and will only manage the labels present in your configuration.
               Please refer to the field `effective_labels` for all of the labels present on the resource.
        :param pulumi.Input[str] location: The location for the resource
               
               
               - - -
        :param pulumi.Input[str] name: The full, unique name of this Feature resource
        :param pulumi.Input[str] project: The ID of the project in which the resource belongs.
               If it is not provided, the provider project is used.
        :param pulumi.Input[Union['FeatureSpecArgs', 'FeatureSpecArgsDict']] spec: Optional. Hub-wide Feature configuration. If this Feature does not support any Hub-wide configuration, this field may be unused.
               Structure is documented below.
        """
        ...
    @overload
    def __init__(__self__,
                 resource_name: str,
                 args: FeatureArgs,
                 opts: Optional[pulumi.ResourceOptions] = None):
        """
        Feature represents the settings and status of any Hub Feature.

        To get more information about Feature, see:

        * [API documentation](https://cloud.google.com/anthos/fleet-management/docs/reference/rest/v1/projects.locations.features)
        * How-to Guides
            * [Registering a Cluster](https://cloud.google.com/anthos/multicluster-management/connect/registering-a-cluster#register_cluster)

        ## Example Usage

        ### Gkehub Feature Multi Cluster Ingress

        ```python
        import pulumi
        import pulumi_gcp as gcp

        cluster = gcp.container.Cluster("cluster",
            name="my-cluster",
            location="us-central1-a",
            initial_node_count=1)
        membership = gcp.gkehub.Membership("membership",
            membership_id="my-membership",
            endpoint={
                "gke_cluster": {
                    "resource_link": cluster.id.apply(lambda id: f"//container.googleapis.com/{id}"),
                },
            })
        feature = gcp.gkehub.Feature("feature",
            name="multiclusteringress",
            location="global",
            spec={
                "multiclusteringress": {
                    "config_membership": membership.id,
                },
            })
        ```
        ### Gkehub Feature Multi Cluster Service Discovery

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="multiclusterservicediscovery",
            location="global",
            labels={
                "foo": "bar",
            })
        ```
        ### Gkehub Feature Anthos Service Mesh

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="servicemesh",
            location="global")
        ```
        ### Enable Fleet Observability For Default Logs With Copy

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="fleetobservability",
            location="global",
            spec={
                "fleetobservability": {
                    "logging_config": {
                        "default_config": {
                            "mode": "COPY",
                        },
                    },
                },
            })
        ```
        ### Enable Fleet Observability For Scope Logs With Move

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="fleetobservability",
            location="global",
            spec={
                "fleetobservability": {
                    "logging_config": {
                        "fleet_scope_logs_config": {
                            "mode": "MOVE",
                        },
                    },
                },
            })
        ```
        ### Enable Fleet Observability For Both Default And Scope Logs

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="fleetobservability",
            location="global",
            spec={
                "fleetobservability": {
                    "logging_config": {
                        "default_config": {
                            "mode": "COPY",
                        },
                        "fleet_scope_logs_config": {
                            "mode": "MOVE",
                        },
                    },
                },
            })
        ```
        ### Enable Fleet Default Member Config Service Mesh

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="servicemesh",
            location="global",
            fleet_default_member_config={
                "mesh": {
                    "management": "MANAGEMENT_AUTOMATIC",
                },
            })
        ```
        ### Enable Fleet Default Member Config Configmanagement

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="configmanagement",
            location="global",
            fleet_default_member_config={
                "configmanagement": {
                    "config_sync": {
                        "git": {
                            "sync_repo": "https://github.com/hashicorp/terraform",
                        },
                    },
                },
            })
        ```
        ### Enable Fleet Default Member Config Policycontroller

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="policycontroller",
            location="global",
            fleet_default_member_config={
                "policycontroller": {
                    "policy_controller_hub_config": {
                        "install_spec": "INSTALL_SPEC_ENABLED",
                        "exemptable_namespaces": ["foo"],
                        "policy_content": {
                            "bundles": [{
                                "bundle": "policy-essentials-v2022",
                                "exempted_namespaces": [
                                    "foo",
                                    "bar",
                                ],
                            }],
                            "template_library": {
                                "installation": "ALL",
                            },
                        },
                        "audit_interval_seconds": 30,
                        "referential_rules_enabled": True,
                    },
                },
            })
        ```
        ### Enable Fleet Default Member Config Policycontroller Full

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="policycontroller",
            location="global",
            fleet_default_member_config={
                "policycontroller": {
                    "policy_controller_hub_config": {
                        "install_spec": "INSTALL_SPEC_SUSPENDED",
                        "policy_content": {
                            "bundles": [
                                {
                                    "bundle": "pci-dss-v3.2.1",
                                    "exempted_namespaces": [
                                        "baz",
                                        "bar",
                                    ],
                                },
                                {
                                    "bundle": "nist-sp-800-190",
                                    "exempted_namespaces": [],
                                },
                            ],
                            "template_library": {
                                "installation": "ALL",
                            },
                        },
                        "constraint_violation_limit": 50,
                        "referential_rules_enabled": True,
                        "log_denies_enabled": True,
                        "mutation_enabled": True,
                        "deployment_configs": [
                            {
                                "component": "admission",
                                "replica_count": 2,
                                "pod_affinity": "ANTI_AFFINITY",
                            },
                            {
                                "component": "audit",
                                "container_resources": {
                                    "limits": {
                                        "memory": "1Gi",
                                        "cpu": "1.5",
                                    },
                                    "requests": {
                                        "memory": "500Mi",
                                        "cpu": "150m",
                                    },
                                },
                                "pod_tolerations": [{
                                    "key": "key1",
                                    "operator": "Equal",
                                    "value": "value1",
                                    "effect": "NoSchedule",
                                }],
                            },
                        ],
                        "monitoring": {
                            "backends": ["PROMETHEUS"],
                        },
                    },
                },
            })
        ```
        ### Enable Fleet Default Member Config Policycontroller Minimal

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="policycontroller",
            location="global",
            fleet_default_member_config={
                "policycontroller": {
                    "policy_controller_hub_config": {
                        "install_spec": "INSTALL_SPEC_ENABLED",
                        "policy_content": {},
                        "constraint_violation_limit": 50,
                        "referential_rules_enabled": True,
                        "log_denies_enabled": True,
                        "mutation_enabled": True,
                        "deployment_configs": [{
                            "component": "admission",
                        }],
                        "monitoring": {},
                    },
                },
            })
        ```
        ### Gkehub Feature Clusterupgrade

        ```python
        import pulumi
        import pulumi_gcp as gcp

        feature = gcp.gkehub.Feature("feature",
            name="clusterupgrade",
            location="global",
            spec={
                "clusterupgrade": {
                    "upstream_fleets": [],
                    "post_conditions": {
                        "soaking": "60s",
                    },
                },
            })
        ```

        ## Import

        Feature can be imported using any of these accepted formats:

        * `projects/{{project}}/locations/{{location}}/features/{{name}}`

        * `{{project}}/{{location}}/{{name}}`

        * `{{location}}/{{name}}`

        When using the `pulumi import` command, Feature can be imported using one of the formats above. For example:

        ```sh
        $ pulumi import gcp:gkehub/feature:Feature default projects/{{project}}/locations/{{location}}/features/{{name}}
        ```

        ```sh
        $ pulumi import gcp:gkehub/feature:Feature default {{project}}/{{location}}/{{name}}
        ```

        ```sh
        $ pulumi import gcp:gkehub/feature:Feature default {{location}}/{{name}}
        ```

        :param str resource_name: The name of the resource.
        :param FeatureArgs args: The arguments to use to populate this resource's properties.
        :param pulumi.ResourceOptions opts: Options for the resource.
        """
        ...
    def __init__(__self__, resource_name: str, *args, **kwargs):
        resource_args, opts = _utilities.get_resource_args_opts(FeatureArgs, pulumi.ResourceOptions, *args, **kwargs)
        if resource_args is not None:
            __self__._internal_init(resource_name, opts, **resource_args.__dict__)
        else:
            __self__._internal_init(resource_name, *args, **kwargs)

    def _internal_init(__self__,
                 resource_name: str,
                 opts: Optional[pulumi.ResourceOptions] = None,
                 fleet_default_member_config: Optional[pulumi.Input[Union['FeatureFleetDefaultMemberConfigArgs', 'FeatureFleetDefaultMemberConfigArgsDict']]] = None,
                 labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
                 location: Optional[pulumi.Input[str]] = None,
                 name: Optional[pulumi.Input[str]] = None,
                 project: Optional[pulumi.Input[str]] = None,
                 spec: Optional[pulumi.Input[Union['FeatureSpecArgs', 'FeatureSpecArgsDict']]] = None,
                 __props__=None):
        opts = pulumi.ResourceOptions.merge(_utilities.get_resource_opts_defaults(), opts)
        if not isinstance(opts, pulumi.ResourceOptions):
            raise TypeError('Expected resource options to be a ResourceOptions instance')
        if opts.id is None:
            if __props__ is not None:
                raise TypeError('__props__ is only valid when passed in combination with a valid opts.id to get an existing resource')
            __props__ = FeatureArgs.__new__(FeatureArgs)

            __props__.__dict__["fleet_default_member_config"] = fleet_default_member_config
            __props__.__dict__["labels"] = labels
            if location is None and not opts.urn:
                raise TypeError("Missing required property 'location'")
            __props__.__dict__["location"] = location
            __props__.__dict__["name"] = name
            __props__.__dict__["project"] = project
            __props__.__dict__["spec"] = spec
            __props__.__dict__["create_time"] = None
            __props__.__dict__["delete_time"] = None
            __props__.__dict__["effective_labels"] = None
            __props__.__dict__["pulumi_labels"] = None
            __props__.__dict__["resource_states"] = None
            __props__.__dict__["states"] = None
            __props__.__dict__["update_time"] = None
        secret_opts = pulumi.ResourceOptions(additional_secret_outputs=["effectiveLabels", "pulumiLabels"])
        opts = pulumi.ResourceOptions.merge(opts, secret_opts)
        super(Feature, __self__).__init__(
            'gcp:gkehub/feature:Feature',
            resource_name,
            __props__,
            opts)

    @staticmethod
    def get(resource_name: str,
            id: pulumi.Input[str],
            opts: Optional[pulumi.ResourceOptions] = None,
            create_time: Optional[pulumi.Input[str]] = None,
            delete_time: Optional[pulumi.Input[str]] = None,
            effective_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            fleet_default_member_config: Optional[pulumi.Input[Union['FeatureFleetDefaultMemberConfigArgs', 'FeatureFleetDefaultMemberConfigArgsDict']]] = None,
            labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            location: Optional[pulumi.Input[str]] = None,
            name: Optional[pulumi.Input[str]] = None,
            project: Optional[pulumi.Input[str]] = None,
            pulumi_labels: Optional[pulumi.Input[Mapping[str, pulumi.Input[str]]]] = None,
            resource_states: Optional[pulumi.Input[Sequence[pulumi.Input[Union['FeatureResourceStateArgs', 'FeatureResourceStateArgsDict']]]]] = None,
            spec: Optional[pulumi.Input[Union['FeatureSpecArgs', 'FeatureSpecArgsDict']]] = None,
            states: Optional[pulumi.Input[Sequence[pulumi.Input[Union['FeatureStateArgs', 'FeatureStateArgsDict']]]]] = None,
            update_time: Optional[pulumi.Input[str]] = None) -> 'Feature':
        """
        Get an existing Feature resource's state with the given name, id, and optional extra
        properties used to qualify the lookup.

        :param str resource_name: The unique name of the resulting resource.
        :param pulumi.Input[str] id: The unique provider ID of the resource to lookup.
        :param pulumi.ResourceOptions opts: Options for the resource.
        :param pulumi.Input[str] create_time: Output only. When the Feature resource was created.
        :param pulumi.Input[str] delete_time: Output only. When the Feature resource was deleted.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] effective_labels: All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        :param pulumi.Input[Union['FeatureFleetDefaultMemberConfigArgs', 'FeatureFleetDefaultMemberConfigArgsDict']] fleet_default_member_config: Optional. Fleet Default Membership Configuration.
               Structure is documented below.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] labels: GCP labels for this Feature.
               **Note**: This field is non-authoritative, and will only manage the labels present in your configuration.
               Please refer to the field `effective_labels` for all of the labels present on the resource.
        :param pulumi.Input[str] location: The location for the resource
               
               
               - - -
        :param pulumi.Input[str] name: The full, unique name of this Feature resource
        :param pulumi.Input[str] project: The ID of the project in which the resource belongs.
               If it is not provided, the provider project is used.
        :param pulumi.Input[Mapping[str, pulumi.Input[str]]] pulumi_labels: The combination of labels configured directly on the resource
               and default labels configured on the provider.
        :param pulumi.Input[Sequence[pulumi.Input[Union['FeatureResourceStateArgs', 'FeatureResourceStateArgsDict']]]] resource_states: State of the Feature resource itself.
               Structure is documented below.
        :param pulumi.Input[Union['FeatureSpecArgs', 'FeatureSpecArgsDict']] spec: Optional. Hub-wide Feature configuration. If this Feature does not support any Hub-wide configuration, this field may be unused.
               Structure is documented below.
        :param pulumi.Input[Sequence[pulumi.Input[Union['FeatureStateArgs', 'FeatureStateArgsDict']]]] states: (Output)
               Output only. The "running state" of the Feature in this Hub.
               Structure is documented below.
        :param pulumi.Input[str] update_time: (Output)
               The time this status and any related Feature-specific details were updated. A timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to nine fractional digits. Examples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z"
        """
        opts = pulumi.ResourceOptions.merge(opts, pulumi.ResourceOptions(id=id))

        __props__ = _FeatureState.__new__(_FeatureState)

        __props__.__dict__["create_time"] = create_time
        __props__.__dict__["delete_time"] = delete_time
        __props__.__dict__["effective_labels"] = effective_labels
        __props__.__dict__["fleet_default_member_config"] = fleet_default_member_config
        __props__.__dict__["labels"] = labels
        __props__.__dict__["location"] = location
        __props__.__dict__["name"] = name
        __props__.__dict__["project"] = project
        __props__.__dict__["pulumi_labels"] = pulumi_labels
        __props__.__dict__["resource_states"] = resource_states
        __props__.__dict__["spec"] = spec
        __props__.__dict__["states"] = states
        __props__.__dict__["update_time"] = update_time
        return Feature(resource_name, opts=opts, __props__=__props__)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> pulumi.Output[str]:
        """
        Output only. When the Feature resource was created.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter(name="deleteTime")
    def delete_time(self) -> pulumi.Output[str]:
        """
        Output only. When the Feature resource was deleted.
        """
        return pulumi.get(self, "delete_time")

    @property
    @pulumi.getter(name="effectiveLabels")
    def effective_labels(self) -> pulumi.Output[Mapping[str, str]]:
        """
        All of labels (key/value pairs) present on the resource in GCP, including the labels configured through Pulumi, other clients and services.
        """
        return pulumi.get(self, "effective_labels")

    @property
    @pulumi.getter(name="fleetDefaultMemberConfig")
    def fleet_default_member_config(self) -> pulumi.Output[Optional['outputs.FeatureFleetDefaultMemberConfig']]:
        """
        Optional. Fleet Default Membership Configuration.
        Structure is documented below.
        """
        return pulumi.get(self, "fleet_default_member_config")

    @property
    @pulumi.getter
    def labels(self) -> pulumi.Output[Optional[Mapping[str, str]]]:
        """
        GCP labels for this Feature.
        **Note**: This field is non-authoritative, and will only manage the labels present in your configuration.
        Please refer to the field `effective_labels` for all of the labels present on the resource.
        """
        return pulumi.get(self, "labels")

    @property
    @pulumi.getter
    def location(self) -> pulumi.Output[str]:
        """
        The location for the resource


        - - -
        """
        return pulumi.get(self, "location")

    @property
    @pulumi.getter
    def name(self) -> pulumi.Output[str]:
        """
        The full, unique name of this Feature resource
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def project(self) -> pulumi.Output[str]:
        """
        The ID of the project in which the resource belongs.
        If it is not provided, the provider project is used.
        """
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="pulumiLabels")
    def pulumi_labels(self) -> pulumi.Output[Mapping[str, str]]:
        """
        The combination of labels configured directly on the resource
        and default labels configured on the provider.
        """
        return pulumi.get(self, "pulumi_labels")

    @property
    @pulumi.getter(name="resourceStates")
    def resource_states(self) -> pulumi.Output[Sequence['outputs.FeatureResourceState']]:
        """
        State of the Feature resource itself.
        Structure is documented below.
        """
        return pulumi.get(self, "resource_states")

    @property
    @pulumi.getter
    def spec(self) -> pulumi.Output[Optional['outputs.FeatureSpec']]:
        """
        Optional. Hub-wide Feature configuration. If this Feature does not support any Hub-wide configuration, this field may be unused.
        Structure is documented below.
        """
        return pulumi.get(self, "spec")

    @property
    @pulumi.getter
    def states(self) -> pulumi.Output[Sequence['outputs.FeatureState']]:
        """
        (Output)
        Output only. The "running state" of the Feature in this Hub.
        Structure is documented below.
        """
        return pulumi.get(self, "states")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> pulumi.Output[str]:
        """
        (Output)
        The time this status and any related Feature-specific details were updated. A timestamp in RFC3339 UTC "Zulu" format, with nanosecond resolution and up to nine fractional digits. Examples: "2014-10-02T15:01:23Z" and "2014-10-02T15:01:23.045123456Z"
        """
        return pulumi.get(self, "update_time")

