# coding=utf-8
# *** WARNING: this file was generated by the Pulumi Terraform Bridge (tfgen) Tool. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from .. import _utilities

__all__ = [
    'GetParameterVersionResult',
    'AwaitableGetParameterVersionResult',
    'get_parameter_version',
    'get_parameter_version_output',
]

@pulumi.output_type
class GetParameterVersionResult:
    """
    A collection of values returned by getParameterVersion.
    """
    def __init__(__self__, create_time=None, disabled=None, id=None, name=None, parameter=None, parameter_data=None, parameter_version_id=None, project=None, update_time=None):
        if create_time and not isinstance(create_time, str):
            raise TypeError("Expected argument 'create_time' to be a str")
        pulumi.set(__self__, "create_time", create_time)
        if disabled and not isinstance(disabled, bool):
            raise TypeError("Expected argument 'disabled' to be a bool")
        pulumi.set(__self__, "disabled", disabled)
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if name and not isinstance(name, str):
            raise TypeError("Expected argument 'name' to be a str")
        pulumi.set(__self__, "name", name)
        if parameter and not isinstance(parameter, str):
            raise TypeError("Expected argument 'parameter' to be a str")
        pulumi.set(__self__, "parameter", parameter)
        if parameter_data and not isinstance(parameter_data, str):
            raise TypeError("Expected argument 'parameter_data' to be a str")
        pulumi.set(__self__, "parameter_data", parameter_data)
        if parameter_version_id and not isinstance(parameter_version_id, str):
            raise TypeError("Expected argument 'parameter_version_id' to be a str")
        pulumi.set(__self__, "parameter_version_id", parameter_version_id)
        if project and not isinstance(project, str):
            raise TypeError("Expected argument 'project' to be a str")
        pulumi.set(__self__, "project", project)
        if update_time and not isinstance(update_time, str):
            raise TypeError("Expected argument 'update_time' to be a str")
        pulumi.set(__self__, "update_time", update_time)

    @property
    @pulumi.getter(name="createTime")
    def create_time(self) -> str:
        """
        The time at which the Parameter Version was created.
        """
        return pulumi.get(self, "create_time")

    @property
    @pulumi.getter
    def disabled(self) -> bool:
        """
        The current state of the Parameter Version.
        """
        return pulumi.get(self, "disabled")

    @property
    @pulumi.getter
    def id(self) -> str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter
    def name(self) -> str:
        """
        The resource name of the ParameterVersion. Format:
        `projects/{{project}}/locations/global/parameters/{{parameter_id}}/versions/{{parameter_version_id}}`
        """
        return pulumi.get(self, "name")

    @property
    @pulumi.getter
    def parameter(self) -> str:
        return pulumi.get(self, "parameter")

    @property
    @pulumi.getter(name="parameterData")
    def parameter_data(self) -> str:
        """
        The parameter data.
        """
        return pulumi.get(self, "parameter_data")

    @property
    @pulumi.getter(name="parameterVersionId")
    def parameter_version_id(self) -> str:
        return pulumi.get(self, "parameter_version_id")

    @property
    @pulumi.getter
    def project(self) -> str:
        return pulumi.get(self, "project")

    @property
    @pulumi.getter(name="updateTime")
    def update_time(self) -> str:
        """
        The time at which the Parameter Version was last updated.
        """
        return pulumi.get(self, "update_time")


class AwaitableGetParameterVersionResult(GetParameterVersionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetParameterVersionResult(
            create_time=self.create_time,
            disabled=self.disabled,
            id=self.id,
            name=self.name,
            parameter=self.parameter,
            parameter_data=self.parameter_data,
            parameter_version_id=self.parameter_version_id,
            project=self.project,
            update_time=self.update_time)


def get_parameter_version(parameter: Optional[str] = None,
                          parameter_version_id: Optional[str] = None,
                          project: Optional[str] = None,
                          opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetParameterVersionResult:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_gcp as gcp

    basic = gcp.parametermanager.get_parameter_version(parameter="test-parameter",
        parameter_version_id="test-parameter-version")
    ```


    :param str parameter: The parameter for obtaining the Parameter Version.
           This can be either the reference of the parameter as in `projects/{{project}}/locations/global/parameters/{{parameter_id}}` or only the name of the parameter as in `{{parameter_id}}`.
    :param str parameter_version_id: The version of the parameter to get.
    :param str project: The project for retrieving the Parameter Version. If it's not specified, 
           the provider project will be used.
    """
    __args__ = dict()
    __args__['parameter'] = parameter
    __args__['parameterVersionId'] = parameter_version_id
    __args__['project'] = project
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('gcp:parametermanager/getParameterVersion:getParameterVersion', __args__, opts=opts, typ=GetParameterVersionResult).value

    return AwaitableGetParameterVersionResult(
        create_time=pulumi.get(__ret__, 'create_time'),
        disabled=pulumi.get(__ret__, 'disabled'),
        id=pulumi.get(__ret__, 'id'),
        name=pulumi.get(__ret__, 'name'),
        parameter=pulumi.get(__ret__, 'parameter'),
        parameter_data=pulumi.get(__ret__, 'parameter_data'),
        parameter_version_id=pulumi.get(__ret__, 'parameter_version_id'),
        project=pulumi.get(__ret__, 'project'),
        update_time=pulumi.get(__ret__, 'update_time'))
def get_parameter_version_output(parameter: Optional[pulumi.Input[str]] = None,
                                 parameter_version_id: Optional[pulumi.Input[str]] = None,
                                 project: Optional[pulumi.Input[Optional[str]]] = None,
                                 opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetParameterVersionResult]:
    """
    ## Example Usage

    ```python
    import pulumi
    import pulumi_gcp as gcp

    basic = gcp.parametermanager.get_parameter_version(parameter="test-parameter",
        parameter_version_id="test-parameter-version")
    ```


    :param str parameter: The parameter for obtaining the Parameter Version.
           This can be either the reference of the parameter as in `projects/{{project}}/locations/global/parameters/{{parameter_id}}` or only the name of the parameter as in `{{parameter_id}}`.
    :param str parameter_version_id: The version of the parameter to get.
    :param str project: The project for retrieving the Parameter Version. If it's not specified, 
           the provider project will be used.
    """
    __args__ = dict()
    __args__['parameter'] = parameter
    __args__['parameterVersionId'] = parameter_version_id
    __args__['project'] = project
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('gcp:parametermanager/getParameterVersion:getParameterVersion', __args__, opts=opts, typ=GetParameterVersionResult)
    return __ret__.apply(lambda __response__: GetParameterVersionResult(
        create_time=pulumi.get(__response__, 'create_time'),
        disabled=pulumi.get(__response__, 'disabled'),
        id=pulumi.get(__response__, 'id'),
        name=pulumi.get(__response__, 'name'),
        parameter=pulumi.get(__response__, 'parameter'),
        parameter_data=pulumi.get(__response__, 'parameter_data'),
        parameter_version_id=pulumi.get(__response__, 'parameter_version_id'),
        project=pulumi.get(__response__, 'project'),
        update_time=pulumi.get(__response__, 'update_time')))
